/**
 * $Id: LicenseManager.java 33 2006-03-22 18:22:13Z Gerhard $
 * 
 * Copyright (C) 2006 Gerhard Zlabinger (gerhard.zlabinger@gmail.com)
 *
 * This file is part of Ubertris.
 * 
 * Ubertris is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ubertris is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ubertris; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

package ubertris;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import javax.microedition.rms.RecordStoreException;

final class LicenseManager extends SingleRecordStore {

  protected String getStoreName() {
    return "licenseStore";
  }

  public boolean isLicenseAccepted() {
    return isRecordAvailable();
  }

  public void acceptLicense() {
    ByteArrayOutputStream bos = null;
    DataOutputStream dos = null;

    try {
      bos = new ByteArrayOutputStream();
      dos = new DataOutputStream(bos);

      dos.writeBoolean(true);

      setRecord(bos.toByteArray());
    } catch (RecordStoreException ex) {
      ex.printStackTrace();
    } catch (IOException ex) {
      ex.printStackTrace();
    } finally {
      if (dos != null) {
        try {
          dos.close();
        } catch (IOException e2) {
          e2.printStackTrace();
        }
      }

      if (bos != null) {
        try {
          bos.close();
        } catch (IOException e3) {
          e3.printStackTrace();
        }
      }
    }
  }
}
