/**
 * $Id: UbertrisMIDlet.java 33 2006-03-22 18:22:13Z Gerhard $
 * 
 * Copyright (C) 2006 Gerhard Zlabinger (gerhard.zlabinger@gmail.com)
 *
 * This file is part of Ubertris.
 * 
 * Ubertris is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ubertris is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ubertris; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

package ubertris;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

public final class UbertrisMIDlet extends MIDlet {

    private UbertrisCanvas canvas;

    protected void startApp() {
        final Display display = Display.getDisplay(this);

        final LicenseManager licMan = new LicenseManager();
        if (!licMan.isLicenseAccepted()) {
          final Alert alert = new Alert("Ubertris License", "Ubertris, Copyright (C) 2006 Gerhard Zlabinger\nUbertris comes with ABSOLUTELY NO WARRANTY. This is free software, and you are welcome to redistribute it under certain conditions; for details see 'COPYING' in your distribution.", null, AlertType.INFO);
          alert.setTimeout(Alert.FOREVER);
          alert.setCommandListener(new CommandListener() {
            public void commandAction(Command cmd, Displayable disp) {
              if (cmd == Alert.DISMISS_COMMAND) {
                licMan.acceptLicense();
            
                startApp();
              } else {
                try {
                  destroyApp(true);
                } catch (MIDletStateChangeException e) {
                  e.printStackTrace();
                }
              }
            }
          });

          display.setCurrent(alert);
        } else {
            if (canvas == null)
                canvas = new UbertrisCanvas(this);
        
            display.setCurrent(canvas);
        }
    }

    protected void pauseApp() {
        canvas.pauseGame();
        notifyPaused();
    }

    protected void destroyApp(boolean uc) throws MIDletStateChangeException {
        if (canvas != null)
          canvas.exit();

        notifyDestroyed();
    }
}
